#ifndef _H_CFADFFABE7F4B71B43EB50FC8BAC1F01_ClassifyObject_Request_DCPS_H_
#define _H_CFADFFABE7F4B71B43EB50FC8BAC1F01_ClassifyObject_Request_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ClassifyObject_Request_.h"


namespace object_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ClassifyObject_Request_TypeSupportInterface;

            typedef ClassifyObject_Request_TypeSupportInterface * ClassifyObject_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ClassifyObject_Request_TypeSupportInterface> ClassifyObject_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ClassifyObject_Request_TypeSupportInterface> ClassifyObject_Request_TypeSupportInterface_out;


            class ClassifyObject_Request_DataWriter;

            typedef ClassifyObject_Request_DataWriter * ClassifyObject_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ClassifyObject_Request_DataWriter> ClassifyObject_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ClassifyObject_Request_DataWriter> ClassifyObject_Request_DataWriter_out;


            class ClassifyObject_Request_DataReader;

            typedef ClassifyObject_Request_DataReader * ClassifyObject_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ClassifyObject_Request_DataReader> ClassifyObject_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ClassifyObject_Request_DataReader> ClassifyObject_Request_DataReader_out;


            class ClassifyObject_Request_DataReaderView;

            typedef ClassifyObject_Request_DataReaderView * ClassifyObject_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ClassifyObject_Request_DataReaderView> ClassifyObject_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ClassifyObject_Request_DataReaderView> ClassifyObject_Request_DataReaderView_out;

            struct ClassifyObject_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ClassifyObject_Request_, struct ClassifyObject_Request_Seq_uniq_> ClassifyObject_Request_Seq;
            typedef DDS_DCPSSequence_var < ClassifyObject_Request_Seq> ClassifyObject_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ClassifyObject_Request_Seq> ClassifyObject_Request_Seq_out;

            class  ClassifyObject_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ClassifyObject_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ClassifyObject_Request_TypeSupportInterface_var _var_type;

                static ClassifyObject_Request_TypeSupportInterface_ptr _duplicate (ClassifyObject_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyObject_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyObject_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ClassifyObject_Request_TypeSupportInterface () {};
                ~ClassifyObject_Request_TypeSupportInterface () {};
            private:
                ClassifyObject_Request_TypeSupportInterface (const ClassifyObject_Request_TypeSupportInterface &);
                ClassifyObject_Request_TypeSupportInterface & operator = (const ClassifyObject_Request_TypeSupportInterface &);
            };

            class  ClassifyObject_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ClassifyObject_Request_DataWriter_ptr _ptr_type;
                typedef ClassifyObject_Request_DataWriter_var _var_type;

                static ClassifyObject_Request_DataWriter_ptr _duplicate (ClassifyObject_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyObject_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyObject_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ClassifyObject_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ClassifyObject_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ClassifyObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ClassifyObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ClassifyObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ClassifyObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ClassifyObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ClassifyObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ClassifyObject_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ClassifyObject_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ClassifyObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyObject_Request_& instance_data) = 0;

            protected:
                ClassifyObject_Request_DataWriter () {};
                ~ClassifyObject_Request_DataWriter () {};
            private:
                ClassifyObject_Request_DataWriter (const ClassifyObject_Request_DataWriter &);
                ClassifyObject_Request_DataWriter & operator = (const ClassifyObject_Request_DataWriter &);
            };

            class  ClassifyObject_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ClassifyObject_Request_DataReader_ptr _ptr_type;
                typedef ClassifyObject_Request_DataReader_var _var_type;

                static ClassifyObject_Request_DataReader_ptr _duplicate (ClassifyObject_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyObject_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyObject_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyObject_Request_& instance) = 0;

            protected:
                ClassifyObject_Request_DataReader () {};
                ~ClassifyObject_Request_DataReader () {};
            private:
                ClassifyObject_Request_DataReader (const ClassifyObject_Request_DataReader &);
                ClassifyObject_Request_DataReader & operator = (const ClassifyObject_Request_DataReader &);
            };

            class  ClassifyObject_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ClassifyObject_Request_DataReaderView_ptr _ptr_type;
                typedef ClassifyObject_Request_DataReaderView_var _var_type;

                static ClassifyObject_Request_DataReaderView_ptr _duplicate (ClassifyObject_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ClassifyObject_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ClassifyObject_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ClassifyObject_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ClassifyObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ClassifyObject_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ClassifyObject_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ClassifyObject_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ClassifyObject_Request_& instance) = 0;

            protected:
                ClassifyObject_Request_DataReaderView () {};
                ~ClassifyObject_Request_DataReaderView () {};
            private:
                ClassifyObject_Request_DataReaderView (const ClassifyObject_Request_DataReaderView &);
                ClassifyObject_Request_DataReaderView & operator = (const ClassifyObject_Request_DataReaderView &);
            };
        }

    }

}

#endif
