// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef OBJECT_MSGS__SRV__DETECT_OBJECT__RESPONSE__STRUCT_HPP_
#define OBJECT_MSGS__SRV__DETECT_OBJECT__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "object_msgs/msg/objects_in_boxes.hpp"  // objects

#ifndef _WIN32
# define DEPRECATED_object_msgs_srv_DetectObject_Response __attribute__((deprecated))
#else
# define DEPRECATED_object_msgs_srv_DetectObject_Response __declspec(deprecated)
#endif

namespace object_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectObject_Response_
{
  using Type = DetectObject_Response_<ContainerAllocator>;

  explicit DetectObject_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : objects(_init)
  {
    (void)_init;
  }

  explicit DetectObject_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : objects(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _objects_type =
    object_msgs::msg::ObjectsInBoxes_<ContainerAllocator>;
  _objects_type objects;

  // setters for named parameter idiom
  Type * set__objects(
    const object_msgs::msg::ObjectsInBoxes_<ContainerAllocator> & _arg)
  {
    this->objects = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    object_msgs::srv::DetectObject_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const object_msgs::srv::DetectObject_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      object_msgs::srv::DetectObject_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      object_msgs::srv::DetectObject_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_object_msgs_srv_DetectObject_Response
    std::shared_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_object_msgs_srv_DetectObject_Response
    std::shared_ptr<object_msgs::srv::DetectObject_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectObject_Response_ & other) const
  {
    if (this->objects != other.objects) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectObject_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectObject_Response_

// alias to use template instance with default allocator
using DetectObject_Response =
  object_msgs::srv::DetectObject_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace object_msgs

#endif  // OBJECT_MSGS__SRV__DETECT_OBJECT__RESPONSE__STRUCT_HPP_
